searchData={"items":[{"type":"module","doc":"The `OffBroadway.EMQTT.Broker` is started as part of the Broadway pipeline\nsupervision tree and is responsible for managing the connection to the MQTT\nbroker and cache incoming messages until the producer is ready to consume them.","title":"OffBroadway.EMQTT.Broker","ref":"OffBroadway.EMQTT.Broker.html"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Broker.check_buffer_threshold/4","ref":"OffBroadway.EMQTT.Broker.html#check_buffer_threshold/4"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"OffBroadway.EMQTT.Broker.child_spec/1","ref":"OffBroadway.EMQTT.Broker.html#child_spec/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Broker.start_link/1","ref":"OffBroadway.EMQTT.Broker.html#start_link/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Broker.stop_emqtt/1","ref":"OffBroadway.EMQTT.Broker.html#stop_emqtt/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Broker.stream_from_buffer/1","ref":"OffBroadway.EMQTT.Broker.html#stream_from_buffer/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Broker.stream_from_buffer_log/1","ref":"OffBroadway.EMQTT.Broker.html#stream_from_buffer_log/1"},{"type":"behaviour","doc":"Behaviour for handling messages received from the MQTT broker.\nCustom message handlers can be implemented by defining a module that implements this behaviour.","title":"OffBroadway.EMQTT.MessageHandler","ref":"OffBroadway.EMQTT.MessageHandler.html"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.MessageHandler.ack_message/2","ref":"OffBroadway.EMQTT.MessageHandler.html#ack_message/2"},{"type":"type","doc":"","title":"OffBroadway.EMQTT.MessageHandler.broadway/0","ref":"OffBroadway.EMQTT.MessageHandler.html#t:broadway/0"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.MessageHandler.handle_connect/1","ref":"OffBroadway.EMQTT.MessageHandler.html#handle_connect/1"},{"type":"callback","doc":"Callback invoked after a successful connection to the MQTT broker.","title":"OffBroadway.EMQTT.MessageHandler.handle_connect/1","ref":"OffBroadway.EMQTT.MessageHandler.html#c:handle_connect/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.MessageHandler.handle_disconnect/1","ref":"OffBroadway.EMQTT.MessageHandler.html#handle_disconnect/1"},{"type":"callback","doc":"Callback invoked after a disconnect from the MQTT broker.","title":"OffBroadway.EMQTT.MessageHandler.handle_disconnect/1","ref":"OffBroadway.EMQTT.MessageHandler.html#c:handle_disconnect/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.MessageHandler.handle_message/3","ref":"OffBroadway.EMQTT.MessageHandler.html#handle_message/3"},{"type":"callback","doc":"Messages are passed to this function after the producer has received them from the MQTT broker.","title":"OffBroadway.EMQTT.MessageHandler.handle_message/3","ref":"OffBroadway.EMQTT.MessageHandler.html#c:handle_message/3"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.MessageHandler.handle_pubrel/1","ref":"OffBroadway.EMQTT.MessageHandler.html#handle_pubrel/1"},{"type":"callback","doc":"`PUBREL` messages received from the MQTT broker are passed to this function.","title":"OffBroadway.EMQTT.MessageHandler.handle_pubrel/1","ref":"OffBroadway.EMQTT.MessageHandler.html#c:handle_pubrel/1"},{"type":"type","doc":"","title":"OffBroadway.EMQTT.MessageHandler.message/0","ref":"OffBroadway.EMQTT.MessageHandler.html#t:message/0"},{"type":"type","doc":"","title":"OffBroadway.EMQTT.MessageHandler.reason_code/0","ref":"OffBroadway.EMQTT.MessageHandler.html#t:reason_code/0"},{"type":"module","doc":"An MQTT producer based on [emqtt](https://github.com/emqx/emqtt) for Broadway.","title":"OffBroadway.EMQTT.Producer","ref":"OffBroadway.EMQTT.Producer.html"},{"type":"module","doc":"* `:buffer_size` (`t:pos_integer/0`) - The maximum number of messages that can be buffered The default value is `10000`.\n\n* `:buffer_overflow_strategy` - The strategy to use when the buffer is full The default value is `:reject`.\n\n* `:buffer_durability` - Set to `:durable` to write buffer log to disk, or `:transient` to keep it in memory The default value is `:transient`.\n\n* `:buffer_log_dir` - A string or zero-arity function that returns the directory to store the buffer log The default value is `&System.tmp_dir/0`.\n\n* `:topics` (list of tuple of `t:String.t/0`,  values) - The topics to subscribe to The default value is `[]`.\n\n* `:message_handler` - A module that implements the `OffBroadway.EMQTT.MessageHandler` behaviour The default value is `OffBroadway.EMQTT.MessageHandler`.\n\n* `:config` (non-empty `t:keyword/0`) - Required. Configuration options that will be sent to the `:emqtt` process.\n\n  * `:host` - Required. The host of the MQTT broker\n\n  * `:port` (`t:pos_integer/0`) - The port to connect to The default value is `1883`.\n\n  * `:username` (`t:String.t/0`) - Username to authenticate with\n\n  * `:password` (`t:String.t/0`) - Password to authenticate with\n\n  * `:ssl` (`t:boolean/0`) - Whether to use SSL\n\n  * `:ssl_opts` (`t:keyword/0`)\n\n    * `:cacertfile` (`t:String.t/0`) - Path to CA certificate file\n\n    * `:server_name_indication` - Server name indication\n\n    * `:verify` - Verify mode The default value is `:verify_peer`.\n\n    * `:certfile` (`t:String.t/0`) - Path to client certificate file\n\n    * `:keyfile` (`t:String.t/0`) - Path to client key file\n\n  * `:ws_path` (`t:String.t/0`) - The path to the resource.\n\n  * `:connect_timeout` (`t:pos_integer/0`) - The timeout in seconds for the connection The default value is `60`.\n\n  * `:bridge_mode` (`t:boolean/0`) - Enable bridge mode or not. The default value is `false`.\n\n  * `:clientid` (`t:String.t/0`) - Specify the client identifier. The default value is `\"emqtt-aa-0-c-383-a765a142ae2d1f8e244f\"`.\n\n  * `:clean_start` (`t:boolean/0`) - Whether the server should discard any existing sessions and start a new one. The default value is `true`.\n\n  * `:proto_ver` - The MQTT protocol version to use. The default value is `:v4`.\n\n  * `:keepalive` (`t:pos_integer/0`) - The maximum time interval in seconds that is permitted to elapse between the client\n    finishes transmitting one MQTT Control Packet and starts sending the next. Will be\n    replaced by server `keepalive` from MQTT server.\n\n  * `:max_inflight` - The maximum number of QoS 1 and QoS 2 packets in flight. This means the number of packets\n    that have been sent, but not yet acked. Will be replaced by server `Receive-Maximum` property\n    in a `CONNACK` package. In that case, the lesser of the two values will act as the limit. The default value is `:infinity`.\n\n  * `:retry_interval` (`t:pos_integer/0`) - Interval in seconds to retry sending packets that have been sent but not received\n    a response. The default value is `30`.\n\n  * `:will_topic` (`t:String.t/0`) - Topic of `will` message, a predefined message that the client sets to be sent by the\n    server in case of an unexpected disconnects.\n\n  * `:will_payload` (`t:String.t/0`) - The payload of the `will` message.\n\n  * `:will_retain` (`t:boolean/0`) - Whether the `will` message should be published as a retained message. The default value is `false`.\n\n  * `:will_qos` - The QoS level of the `will` message. The default value is `0`.\n\n  * `:auto_ack` (`t:boolean/0`) - The client process will automacally send ack packages like `PUBACK` when receiving a packet. The default value is `true`.\n\n  * `:ack_timeout` (`t:pos_integer/0`) - The timeout in seconds for the ack package. The default value is `30`.\n\n  * `:force_ping` (`t:boolean/0`) - If false and any other packets are sent during the `keepalive` interval, the ping packet will\n    not be sent this time. If true, the ping packet will be sent regardless of other packets. The default value is `false`.\n\n  * `:custom_auth_callbacks` - A map of custom authentication callback MFAs. This configuration enables enhanced authentication\n    mechanisms in MQTT v5.","title":"Producer options - OffBroadway.EMQTT.Producer","ref":"OffBroadway.EMQTT.Producer.html#module-producer-options"},{"type":"module","doc":"TBD","title":"Acknowledgements - OffBroadway.EMQTT.Producer","ref":"OffBroadway.EMQTT.Producer.html#module-acknowledgements"},{"type":"module","doc":"This library exposes the following telemetry events:\n  * `[:off_broadway_emqtt, :replay_buffer, :start]` - Dispatched when the `OffBroadway.EMQTT.Broker`\n    process is started if the `buffer_durability` option is set to `:durable`.\n\n    * measurement: `%{time: System.monotonic_time}`\n    * metadata: `%{client_id: string, buffer_size: non_neg_integer}`\n\n    _This event is only dispatched if the `buffer_durability` option is set to `:durable`._\n\n    When this event is dispatched, the `buffer_size` contains the number of messages currently in\n    the disk log, not the ETS buffer.\n\n  * `[:off_broadway_emqtt, :replay_buffer, :stop]` - Dispatched after the `OffBroadway.EMQTT.Broker`\n    process has replayed and truncated the disk log.\n\n    * measurement: `%{time: System.monotonic_time}`\n    * metadata: `%{client_id: string, buffer_size: non_neg_integer}`\n\n    _This event is only dispatched if the `buffer_durability` option is set to `:durable`._\n\n    When this event is dispatched, the `buffer_size` contains the number of messages remaining in\n    the disk log (should be 0 to indicate all logged events was replayed to the ETS cache).\n\n  * `[:off_broadway_emqtt, :sync_buffer, :start]` - Dispatched when the `OffBroadway.EMQTT.Broker`\n    process terminates and the ETS buffer is synced to the disk log.\n\n    * measurement: `%{time: System.monotonic_time}`\n    * metadata: `%{client_id: string, buffer_size: non_neg_integer}`\n\n    _This event is only dispatched if the `buffer_durability` option is set to `:durable`._\n\n    When this event is dispatched, the `buffer_size` contains the number of messages that should be\n    written to the disk log.\n\n  * `[:off_broadway_emqtt, :sync_buffer, :stop]` - Dispatched after the `OffBroadway.EMQTT.Broker`\n    process has written the ETS buffer to the disk log.\n\n    * measurement: `%{time: System.monotonic_time}`\n    * metadata: `%{client_id: string, buffer_size: non_neg_integer}`\n\n    _This event is only dispatched if the `buffer_durability` option is set to `:durable`._\n\n    When this event is dispatched, the `buffer_size` contains the number of messages that has been\n    written to the disk log.\n\n  * `[:off_broadway_emqtt, :receive_messages, :start]` - Dispatched before messages are received from\n    the `ETS` buffer.\n\n      * measurement: `%{time: System.monotonic_time}`\n      * metadata: `%{client_id: string, demand: non_neg_integer}`\n\n\n   * `[:off_broadway_emqtt, :receive_messages, :stop]` - Dispatched after messages have been\n    received from the `ETS` buffer and \"wrapped\".\n\n      * measurement: `%{time: native_time}`\n      * metadata: `%{client_id: string, topics: [string], received: non_neg_integer, demand: non_neg_integer}`\n\n\n  * `[:off_broadway_emqtt, :receive_messages, :exception]` - Dispatched after a failure while\n    receiving messages from the `ETS` buffer.\n\n    * measurement: `%{duration: native_time}`\n    * metadata: `%{client_id: string, demand: non_neg_integer, reason: reason, stacktrace: stacktrace}`\n\n\n  * `[:off_broadway_emqtt, :receive_messages, :ack]` - Dispatched when acking a message if using\n    the default `OffBroadway.EMQTT.MessageHandler` implementation.\n\n    * measurement: `%{time: System.system_time, count: 1}`\n    * metadata: `%{topic: string, receipt: receipt}`\n\n\n  * `[:off_broadway_emqtt, :buffer, :accept_message]` - Dispatched when a message is stored\n    into the `ETS` buffer.\n\n    * measurement: `%{time: System.system_time, count: 1}`\n    * metadata: `%{client_id: string, topic: string, buffer_size: non_neg_integer}`\n\n\n  * `[:off_broadway_emqtt, :buffer, :reject_message]` - Dispatched when a message is rejected\n    to be stored in the `ETS` buffer because it is full. This occurs when the buffer is full\n    and the `buffer_overflow_strategy` is set to `:reject`.\n\n    * measurement: `%{time: System.system_time, count: 1}`\n    * metadata: `%{client_id: string, topic: string, buffer_size: non_neg_integer}`\n\n\n  * `[:off_broadway_emqtt, :buffer, :drop_message]` - Dispatched when a message is dropped from\n    the `ETS` buffer to make space for a new. This occurs when the buffer is full and the\n    `buffer_overflow_strategy` is set to `:drop_head`.\n\n    * measurement: `%{time: System.system_time, count: 1}`\n    * metadata: `%{client_id: string, topic: string, buffer_size: non_neg_integer}`\n\n  * `[:off_broadway_emqtt, :buffer, :log_write]` - Dispatched when a message is written to the disk log.\n\n    * measurement: `%{time: System.system_time, count: 1}`\n    * metadata: `%{client_id: string, topic: string, buffer_size: non_neg_integer}`\n\n    _This event is only dispatched if the `buffer_durability` option is set to `:durable`._\n\n    When this event is dispatched, the `buffer_size` contains the number of messages currently in\n    the disk log, not the ETS buffer.","title":"Telemetry - OffBroadway.EMQTT.Producer","ref":"OffBroadway.EMQTT.Producer.html#module-telemetry"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Producer.emqtt_process_name/1","ref":"OffBroadway.EMQTT.Producer.html#emqtt_process_name/1"},{"type":"function","doc":"","title":"OffBroadway.EMQTT.Producer.message_handler_module/1","ref":"OffBroadway.EMQTT.Producer.html#message_handler_module/1"},{"type":"extras","doc":"# OffBroadway.EMQTT\n\n![Elixir CI](https://github.com/Intility/off_broadway_emqtt/actions/workflows/elixir.yaml/badge.svg?event=push&branch=main)\n[![License: Apache 2.0 ](https://img.shields.io/badge/License-Apache2-yellow.svg)](https://opensource.org/license/apache-2-0)\n[![Hex version badge](https://img.shields.io/hexpm/v/off_broadway_emqtt.svg)](https://hex.pm/packages/off_broadway_emqtt)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/off_broadway_emqtt/readme.html)\n\nAn MQTT connector based on [emqtt](https://github.com/emqx/emqtt) for [Broadway](https://github.com/dashbitco/broadway).\n\nMQTT (Message Queuing Telemetry Transport) is a lightweight messaging protocol designed for small sensors and mobile devices \nwith limited bandwidth. MQTT is commonly used in IoT (Internet of Things), home and industrial automation, healthcare and energy management\namongst others.\n\nSeveral well-known systems and cloud providers provides MQTT broker services that can be used to build automation systems. These includes\nAmazon Web Services (AWS IoT), Microsoft Azure (IoT Hub, Event Grid), IBM Watson IoT Platform and Eclipse Mosquitto.","title":"OffBroadway.EMQTT","ref":"readme.html"},{"type":"extras","doc":"``` elixir\ndefmodule MyBroadway do \n  use Broadway\n  alias Broadway.Message\n  \n  def start_link(_opts) do \n    Broadway.start_link(__MODULE__,\n      name: __MODULE__,\n      producer: [\n        module: {OffBroadway.EMQTT.Producer, \n           topics: [\n             {\"test/topic1\", :at_most_once},     # QoS 0\n             {\"test/topic2\", :at_least_once},    # QoS 1\n             {\"test/topic3\", :exactly_once}      # QoS 2\n           ],\n           buffer_size: 10_000,                  # Max number of messages in ETS cache before beginning to drop messages\n           buffer_overflow_strategy: :drop_head, # Either :drop_head or :reject\n           buffer_durability: :durable,          # Persist cached messages to disk (:durable) or in-memory only (:transient)\n           buffer_log_dir: System.tmp_dir!(),    # Where to store buffer logs if using :durable buffer\n           config: [\n             host: \"test.mosquitto.org\",\n             port: 1884,\n             username: \"rw\",\n             password: \"readwrite\"\n           ]\n        },\n        concurrency: 5\n      ],\n      processors: [\n        default: [concurrency: 10]\n      ],\n      batchers: [\n        default: [\n          batch_size: 200,\n          concurrency: 5 \n        ]\n      ]\n    )\n  end\n  \n  @impl true\n  def handle_message(_, %Message{} = message, _) do \n    IO.inspect(message, label: \"Handled message from producer\")\n  end\n  \n  @impl true\n  def handle_batch(_, messages, _, _) do \n    IO.inspect(\"Received a batch of #{length(messages)} messages\", label: \"Handled batch from producer\")\n    messages\n  end\nend\n```","title":"Usage - OffBroadway.EMQTT","ref":"readme.html#usage"},{"type":"extras","doc":"This package is [available in Hex](https://hex.pm/packages/off_broadway_emqtt), and can be installed\nby adding `off_broadway_emqtt` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:off_broadway_emqtt, \"~> 0.2.0\"}, \n    {:cowlib, \"~> 2.12\", override: true} # Required for `:emqtt` dependency resolution\n  ]\nend\n```\n\nBy default, `:emqtt` compiles the `Quic` library. It is possible to build without by setting the environment variable\n`BUILD_WITHOUT_QUIC=1`.\n\n``` shell\nBUILD_WITHOUT_QUIC=1 mix deps.compile\n```","title":"Installation - OffBroadway.EMQTT","ref":"readme.html#installation"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"_Released unreleased_\n\n- Add support for wrapping the ETS buffer cache with [:disk_log](https://www.erlang.org/docs/17/man/disk_log) to persist cached messages for producer.\n  - Introduced new option `buffer_durability` which can be either `:durable` or `:transient`. When `:durable`, \n    messages will be persisted to disk to ensure messages are not lost if the producer crashes. Defaults to\n    `:transient` (in-memory buffer only).\n  - New option `buffer_log_dir` can be either a string, or a zero-arity function that returns the directory to\n    store buffer logs.\n  - Added new telemetry events for `:durable` buffer operations.","title":"v0.2.0 - Patch - Changelog","ref":"changelog.html#v0-2-0-patch"},{"type":"extras","doc":"_Released unreleased_\n\n- Emitting `off_broadway_emqtt.receive_message.ack` reads message topic from message receipt instead of from the message body.\n This ensures that topic is included in telemetry events even if the message has been altered during dispatch.\n- Move `emqtt.start_link/1` and `emqtt.connect/1` to a `handle_continue/2` callback to prevent blocking `GenServer.init/1`.\n- Convert `host` and `server_name_indication` to charlist when validating options.\n- Return new state from `handle_continue` on connection error.\n- Publish the `payload` field as message data, and the rest as metadata.","title":"v0.1.1 - Patch - Changelog","ref":"changelog.html#v0-1-1-patch"},{"type":"extras","doc":"_Released 2024-09-24_\n\nThe initial release supports connecting to an MQTT broker using  [emqtt](https://github.com/emqx/emqtt), \nand consume messages using a Broadway pipeline.\n\n**Supported features**\n- [x] Support most  `emqtt` configurable options as producer config options.\n- [x] Specify buffer size and overflow strategy for the `ets` table buffer.\n- [x] `OffBroadway.EMQTT.MessageHandler` behaviour to support overriding default implementation.\n- [x] Telemetry events for observability.","title":"v0.1.0 - Initial release - Changelog","ref":"changelog.html#v0-1-0-initial-release"},{"type":"extras","doc":"Copyright 2024 Intility\n\n                                 Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","title":"LICENSE","ref":"license.html"}],"proglang":"elixir","producer":{"name":"ex_doc","version":"0.38.2"},"content_type":"text/markdown"}